OGRE-Next: Ogre::RotationalSpline Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::RotationalSpline Class Reference
Core » Math

This class interpolates orientations (rotations) along a spline using derivatives of quaternions. More...

`#include <OgreRotationalSpline.h>`

## Public Member Functions
| RotationalSpline ()
| ~RotationalSpline ()
void | addPoint (const Quaternion &p)
| Adds a control point to the end of the spline.
void | clear ()
| Clears all the points in the spline.
unsigned short | getNumPoints () const
| Gets the number of control points in the spline.
const Quaternion & | getPoint (unsigned short index) const
| Gets the detail of one of the control points of the spline.
Quaternion | interpolate (Real t, bool useShortestPath=true)
| Returns an interpolated point based on a parametric value over the whole series.
Quaternion | interpolate (unsigned int fromIndex, Real t, bool useShortestPath=true)
| Interpolates a single segment of the spline given a parametric value.
void | recalcTangents ()
| Recalculates the tangents associated with this spline.
void | setAutoCalculate (bool autoCalc)
| Tells the spline whether it should automatically calculate tangents on demand as points are added.
void | updatePoint (unsigned short index, const Quaternion &value)
| Updates a single point in the spline.

## Detailed Description

This class interpolates orientations (rotations) along a spline using derivatives of quaternions.

Remarks
  Like the SimpleSpline class, this class is about interpolating values smoothly over a spline. Whilst SimpleSpline deals with positions (the normal sense we think about splines), this class interpolates orientations. The theory is identical, except we're now in 4-dimensional space instead of 3.

  In positional splines, we use the points and tangents on those points to generate control points for the spline. In this case, we use quaternions and derivatives of the quaternions (i.e. the rate and direction of change at each point). This is the same as SimpleSpline since a tangent is a derivative of a position. We effectively generate an extra quaternion in between each actual quaternion which when take with the original quaternion forms the 'tangent' of that quaternion.

## Constructor & Destructor Documentation

## ◆ RotationalSpline()

Ogre::RotationalSpline::RotationalSpline | ( |  | ) |

## ◆ ~RotationalSpline()

Ogre::RotationalSpline::~RotationalSpline | ( |  | ) |

## Member Function Documentation

## ◆ addPoint()

void Ogre::RotationalSpline::addPoint | ( | const Quaternion & | p | ) |

Adds a control point to the end of the spline.

## ◆ clear()

void Ogre::RotationalSpline::clear | ( |  | ) |

Clears all the points in the spline.

## ◆ getNumPoints()

unsigned short Ogre::RotationalSpline::getNumPoints | ( |  | ) | const

Gets the number of control points in the spline.

## ◆ getPoint()

const Quaternion & Ogre::RotationalSpline::getPoint | ( | unsigned short | index | ) | const

Gets the detail of one of the control points of the spline.

## ◆ interpolate() [1/2]

Quaternion Ogre::RotationalSpline::interpolate | ( | Real | t,
|  | bool | useShortestPath = true )

Returns an interpolated point based on a parametric value over the whole series.

Remarks
  Given a t value between 0 and 1 representing the parametric distance along the whole length of the spline, this method returns an interpolated point.

Parameters

  t | Parametric value.
  useShortestPath | Defines if rotation should take the shortest possible path

## ◆ interpolate() [2/2]

Quaternion Ogre::RotationalSpline::interpolate | ( | unsigned int | fromIndex,
|  | Real | t,
|  | bool | useShortestPath = true )

Interpolates a single segment of the spline given a parametric value.

Parameters

  fromIndex | The point index to treat as t=0. fromIndex + 1 is deemed to be t=1
  t | Parametric value
  useShortestPath | Defines if rotation should take the shortest possible path

## ◆ recalcTangents()

void Ogre::RotationalSpline::recalcTangents | ( |  | ) |

Recalculates the tangents associated with this spline.

Remarks
  If you tell the spline not to update on demand by calling setAutoCalculate(false) then you must call this after completing your updates to the spline points.

## ◆ setAutoCalculate()

void Ogre::RotationalSpline::setAutoCalculate | ( | bool | autoCalc | ) |

Tells the spline whether it should automatically calculate tangents on demand as points are added.

Remarks
  The spline calculates tangents at each point automatically based on the input points. Normally it does this every time a point changes. However, if you have a lot of points to add in one go, you probably don't want to incur this overhead and would prefer to defer the calculation until you are finished setting all the points. You can do this by calling this method with a parameter of 'false'. Just remember to manually call the recalcTangents method when you are done.

Parameters

  autoCalc | If true, tangents are calculated for you whenever a point changes. If false, you must call reclacTangents to recalculate them when it best suits.

## ◆ updatePoint()

void Ogre::RotationalSpline::updatePoint | ( | unsigned short | index,
|  | const Quaternion & | value )

Updates a single point in the spline.

Remarks
  This point must already exist in the spline.

The documentation for this class was generated from the following file:

- OgreRotationalSpline.h